	.module adc.c
	.area text(rom, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
	.area data(ram, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
_countVD::
	.blkb 1
	.area idata
	.byte 128
	.area data(ram, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
	.dbsym e countVD _countVD c
_count::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
	.dbsym e count _count c
_f_adc::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
	.dbsym e f_adc _f_adc c
_countBuf::
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
	.dbsym e countBuf _countBuf s
_countFIR::
	.blkb 2
	.area idata
	.word 512
	.area data(ram, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
	.dbsym e countFIR _countFIR s
_ukaz::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
	.dbsym e ukaz _ukaz c
_countStr::
	.blkb 2
	.area idata
	.word 30
	.area data(ram, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
	.dbsym e countStr _countStr i
_countStrTek::
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
	.dbsym e countStrTek _countStrTek i
_portb1::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
	.dbsym e portb1 _portb1 c
_f_fir::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
	.dbsym e f_fir _f_fir c
_firN::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
	.dbsym e firN _firN c
_smech::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
	.dbsym e smech _smech c
	.area text(rom, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
	.dbfunc e init_devices _init_devices fV
	.even
_init_devices::
	.dbline -1
	.dbline 49
; //ICC-AVR application builder : 11.03.2009 10:09:26
; // Target : M16
; // Crystal: 16.0000Mhz
; 
; #include <iom16v.h>
; #include <macros.h>
; #include "math.h"
; #include "DFT_AVR.h"
; 
; unsigned char value;
; 
; unsigned char countVD = 128;
; unsigned char count = 0;
; unsigned char N;
; volatile unsigned char f_adc = 0;
; 
; unsigned char buffer[512];
; unsigned char *buffer_ukaz;
; 
; unsigned short countBuf = 0;
; unsigned short countFIR = 512;
; 
; char ukaz=0;				   
; unsigned int countStr = 30;
; unsigned int countStrTek = 0;
; char portb1 = 0;
; 
; unsigned char f_fir = 0;
; unsigned char firN = 0;
; unsigned char Uadc;
; unsigned char Uadc1;
; unsigned char Uadc3;
; unsigned char Uadc2;
; unsigned char Uadc4;
; unsigned char Uadc5;
; unsigned char Uadc6;
; unsigned char Uadc7;
; unsigned char Uadc8;
; unsigned char Uadc9;
; unsigned char Uadc10;
; unsigned char Uadc11;
; unsigned char Uadc12;
; unsigned char smech = 0;
; 
; void VD_select(void);
; 
; //call this routine to initialize all peripherals
; void init_devices(void)
; { 
	.dbline 51
;  //stop errant interrupts until set up
;  CLI(); //disable all interrupts
	cli
	.dbline 53
;  
;  buffer_ukaz = buffer;
	ldi R24,<_buffer
	ldi R25,>_buffer
	sts _buffer_ukaz+1,R25
	sts _buffer_ukaz,R24
	.dbline 55
;  //  
;  DDRA  = 0xFE;
	ldi R24,254
	out 0x1a,R24
	.dbline 56
;  PORTA = 0x00; 
	clr R2
	out 0x1b,R2
	.dbline 57
;  DDRB  = 0xFF;
	ldi R24,255
	out 0x17,R24
	.dbline 58
;  PORTB = 0x1C; 
	ldi R24,28
	out 0x18,R24
	.dbline 59
;  PORTC = 0x00; //m103 output only
	out 0x15,R2
	.dbline 60
;  DDRC  = 0xFF;
	ldi R24,255
	out 0x14,R24
	.dbline 61
;  DDRD  = 0xFF;
	out 0x11,R24
	.dbline 62
;  PORTD = 0x00;//0x40; 
	out 0x12,R2
	.dbline 64
;  //   : 52 uS 19.2 
;  ADCSR = 0x00; //disable adc
	out 0x6,R2
	.dbline 65
;  ADMUX = 0x00; //select adc input 0 //    
	out 0x7,R2
	.dbline 66
;  ACSR  = 0x80;
	ldi R24,128
	out 0x8,R24
	.dbline 67
;  ADCSR = 0xEE; //0xCD; 
	ldi R24,238
	out 0x6,R24
	.dbline 69
; 
;  MCUCR = 0x12; 
	ldi R24,18
	out 0x35,R24
	.dbline 70
;  GICR  = 0x00;
	out 0x3b,R2
	.dbline 71
;  TIMSK = 0x00; //timer interrupt sources
	out 0x39,R2
	.dbline 72
;  SEI(); //re-enable interrupts
	sei
	.dbline 74
;  //all peripherals are now initialized 
;  asm("sleep"); //    ,     
	sleep
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e main _main fV
	.even
_main::
	.dbline -1
	.dbline 79
; }
; 
; //
; void main(void)
; {
	.dbline 80
;  init_devices();
	xcall _init_devices
	xjmp L4
L6:
	.dbline 84
;  //insert your functional code here... 
;  while(1)
;  {
;     while(f_adc==0);   
L7:
	.dbline 84
	lds R2,_f_adc
	tst R2
	breq L6
X0:
	.dbline 86
;     //----------------- 
; 	Uadc1 = DFT_1(buffer_ukaz);	
	lds R16,_buffer_ukaz
	lds R17,_buffer_ukaz+1
	xcall _DFT_1
	sts _Uadc1,R16
	.dbline 87
; 	Uadc2 = DFT_2(buffer_ukaz);
	lds R16,_buffer_ukaz
	lds R17,_buffer_ukaz+1
	xcall _DFT_2
	sts _Uadc2,R16
	.dbline 88
; 	Uadc3 = DFT_3(buffer_ukaz);
	lds R16,_buffer_ukaz
	lds R17,_buffer_ukaz+1
	xcall _DFT_3
	mov R10,R16
	sts _Uadc3,R10
	.dbline 89
; 	Uadc4 = DFT_4(buffer_ukaz); 
	lds R16,_buffer_ukaz
	lds R17,_buffer_ukaz+1
	xcall _DFT_4
	mov R10,R16
	sts _Uadc4,R10
	.dbline 90
; 	Uadc5 = DFT_5(buffer_ukaz); 	   		
	lds R16,_buffer_ukaz
	lds R17,_buffer_ukaz+1
	xcall _DFT_5
	mov R10,R16
	sts _Uadc5,R10
	.dbline 91
; 	Uadc6 = DFT_6(buffer_ukaz);  
	lds R16,_buffer_ukaz
	lds R17,_buffer_ukaz+1
	xcall _DFT_6
	mov R10,R16
	sts _Uadc6,R10
	.dbline 92
; 	Uadc7 = DFT_7(buffer_ukaz);	  
	lds R16,_buffer_ukaz
	lds R17,_buffer_ukaz+1
	xcall _DFT_7
	mov R10,R16
	sts _Uadc7,R10
	.dbline 93
; 	Uadc8 = DFT_8(buffer_ukaz);  //  1,2 	
	lds R16,_buffer_ukaz
	lds R17,_buffer_ukaz+1
	xcall _DFT_8
	mov R10,R16
	sts _Uadc8,R10
	.dbline 94
; 	Uadc9 = DFT_9(buffer_ukaz);  
	lds R16,_buffer_ukaz
	lds R17,_buffer_ukaz+1
	xcall _DFT_9
	mov R10,R16
	sts _Uadc9,R10
	.dbline 95
; 	Uadc10 = DFT_10(buffer_ukaz);	
	lds R16,_buffer_ukaz
	lds R17,_buffer_ukaz+1
	xcall _DFT_10
	mov R10,R16
	sts _Uadc10,R10
	.dbline 96
; 	Uadc11 = DFT_11(buffer_ukaz);		  		
	lds R16,_buffer_ukaz
	lds R17,_buffer_ukaz+1
	xcall _DFT_11
	mov R10,R16
	sts _Uadc11,R10
	.dbline 97
;     Uadc12 = DFT_12(buffer_ukaz);	  
	lds R16,_buffer_ukaz
	lds R17,_buffer_ukaz+1
	xcall _DFT_12
	mov R10,R16
	sts _Uadc12,R10
	.dbline 99
; 		
; 	f_adc=0;	
	clr R2
	sts _f_adc,R2
	.dbline 100
; 	MCUCR = 0x12;    //        
	ldi R24,18
	out 0x35,R24
	.dbline 101
;     asm("sleep");	 //           
	sleep
	.dbline 102
;   } 
L4:
	.dbline 82
	xjmp L7
X1:
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 56
	jmp _adc_isr
	.area text(rom, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
	.dbfunc e adc_isr _adc_isr fV
	.even
_adc_isr::
	st -y,R0
	st -y,R1
	st -y,R2
	st -y,R3
	st -y,R4
	st -y,R5
	st -y,R6
	st -y,R7
	st -y,R8
	st -y,R9
	st -y,R16
	st -y,R17
	st -y,R18
	st -y,R19
	st -y,R24
	st -y,R25
	st -y,R26
	st -y,R27
	st -y,R30
	st -y,R31
	in R0,0x3f
	st -y,R0
	.dbline -1
	.dbline 109
; }
; 
; 
; //     19.2kHz
; #pragma interrupt_handler adc_isr:15
; void adc_isr(void)
; {
	.dbline 111
;  //conversion complete, read value (int) using...
;  value  = ADCL>>2;            //Read 8 low bits first (important)
	in R2,0x4
	lsr R2
	lsr R2
	sts _value,R2
	.dbline 112
;  value |= ADCH<<6;  
	in R2,0x5
	lsl R2
	lsl R2
	lsl R2
	lsl R2
	lsl R2
	lsl R2
	lds R3,_value
	or R3,R2
	sts _value,R3
	.dbline 113
;  count++;
	lds R24,_count
	subi R24,255    ; addi 1
	sts _count,R24
	.dbline 114
;  if(count==countVD)           // 
	lds R2,_countVD
	cp R24,R2
	brne L10
X2:
	.dbline 115
;  { 
	.dbline 116
;     count = 0;
	clr R2
	sts _count,R2
	.dbline 117
;     VD_select(); 
	xcall _VD_select
	.dbline 118
;  }	
L10:
	.dbline 119
;  if(f_adc == 0)               //      
	lds R2,_f_adc
	tst R2
	brne L12
X3:
	.dbline 120
;  {
	.dbline 121
;     buffer[countBuf] = value;
	ldi R24,<_buffer
	ldi R25,>_buffer
	lds R30,_countBuf
	lds R31,_countBuf+1
	add R30,R24
	adc R31,R25
	lds R2,_value
	std z+0,R2
	.dbline 122
;     countBuf++; 
	lds R24,_countBuf
	lds R25,_countBuf+1
	adiw R24,1
	sts _countBuf+1,R25
	sts _countBuf,R24
	.dbline 124
;   
;     if(countBuf==countFIR)    //     
	lds R2,_countFIR
	lds R3,_countFIR+1
	cp R24,R2
	cpc R25,R3
	brne L14
X4:
	.dbline 125
;     {
	.dbline 126
;        countBuf=0;
	clr R2
	clr R3
	sts _countBuf+1,R3
	sts _countBuf,R2
	.dbline 127
; 	   f_adc=1;	      	 	  //        
	ldi R24,1
	sts _f_adc,R24
	.dbline 128
;     } 
	xjmp L15
L14:
	.dbline 130
;     else
;     { 
	.dbline 131
;        MCUCR = 0x12;          //    ,       
	ldi R24,18
	out 0x35,R24
	.dbline 132
;        asm("sleep");
	sleep
	.dbline 133
;     }
L15:
	.dbline 134
;  }   
L12:
	.dbline -2
L9:
	.dbline 0 ; func end
	ld R0,y+
	out 0x3f,R0
	ld R31,y+
	ld R30,y+
	ld R27,y+
	ld R26,y+
	ld R25,y+
	ld R24,y+
	ld R19,y+
	ld R18,y+
	ld R17,y+
	ld R16,y+
	ld R9,y+
	ld R8,y+
	ld R7,y+
	ld R6,y+
	ld R5,y+
	ld R4,y+
	ld R3,y+
	ld R2,y+
	ld R1,y+
	ld R0,y+
	reti
	.dbend
	.dbfunc e adc_interrupt _adc_interrupt fV
	.even
_adc_interrupt::
	.dbline -1
	.dbline 139
; }
; 
; //---------------------    
; void adc_interrupt(void)
; {
	.dbline 140
;    if(ADCSR&0x10)
	sbis 0x6,4
	rjmp L17
X5:
	.dbline 141
;    {
	.dbline 142
;       count++;
	lds R24,_count
	subi R24,255    ; addi 1
	sts _count,R24
	.dbline 143
;       if(count==countVD)           // 
	lds R2,_countVD
	cp R24,R2
	brne L19
X6:
	.dbline 144
;       { 
	.dbline 145
;          count = 0;
	clr R2
	sts _count,R2
	.dbline 146
; 		 VD_select(); 
	xcall _VD_select
	.dbline 147
;       }	
L19:
	.dbline 148
;    }   
L17:
	.dbline -2
L16:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e VD_select _VD_select fV
	.even
_VD_select::
	.dbline -1
	.dbline 153
; }
; 
; //---------------------  
; void VD_select(void)
; {
	.dbline 154
;     N++;
	lds R24,_N
	subi R24,255    ; addi 1
	sts _N,R24
	.dbline 155
;     switch(N)
	mov R16,R24
	clr R17
	cpi R16,1
	ldi R30,0
	cpc R17,R30
	breq L25
X7:
	cpi R16,2
	ldi R30,0
	cpc R17,R30
	breq L26
X8:
	cpi R16,3
	ldi R30,0
	cpc R17,R30
	breq L27
X9:
	cpi R16,4
	ldi R30,0
	cpc R17,R30
	breq L28
X10:
	xjmp L22
L25:
	.dbline 159
; 	{
; 	   case 1:
; 	      //PORTB = 0x1C;
; 		  PORTD = Uadc1;//privet[ukaz];
	lds R2,_Uadc1
	out 0x12,R2
	.dbline 160
; 		  PORTC = Uadc2;//privet[ukaz+1];
	lds R2,_Uadc2
	out 0x15,R2
	.dbline 161
; 		  PORTA = Uadc3&0xFE;//privet[ukaz+2]&0xFE;
	lds R24,_Uadc3
	andi R24,254
	out 0x1b,R24
	.dbline 162
; 		  portb1 = Uadc3&0x01;//privet[ukaz+2]&0x01;
	lds R24,_Uadc3
	andi R24,1
	sts _portb1,R24
	.dbline 163
; 		  PORTB = portb1|0x1C;			  
	ori R24,28
	out 0x18,R24
	.dbline 164
; 		  break;	      
	xjmp L23
L26:
	.dbline 167
; 	   case 2:
; 	      //PORTB = 0x1A;
; 		  PORTD = Uadc4;//privet[ukaz+3];
	lds R2,_Uadc4
	out 0x12,R2
	.dbline 168
; 		  PORTC = Uadc5;//privet[ukaz+4];
	lds R2,_Uadc5
	out 0x15,R2
	.dbline 169
; 		  PORTA = Uadc6&0xFE;//privet[ukaz+5]&0xFE;
	lds R24,_Uadc6
	andi R24,254
	out 0x1b,R24
	.dbline 170
; 		  portb1 = Uadc6&0x01;//privet[ukaz+5]&0x01;
	lds R24,_Uadc6
	andi R24,1
	sts _portb1,R24
	.dbline 171
; 		  PORTB = portb1|0x1A;	
	ori R24,26
	out 0x18,R24
	.dbline 172
; 		  break;
	xjmp L23
L27:
	.dbline 175
; 	   case 3:
; 	      //PORTB = 0x16;
; 		  PORTD = Uadc7;//privet[ukaz+6];
	lds R2,_Uadc7
	out 0x12,R2
	.dbline 176
; 		  PORTC = Uadc8;//privet[ukaz+7];
	lds R2,_Uadc8
	out 0x15,R2
	.dbline 177
; 		  PORTA = Uadc9&0xFE;//privet[ukaz+8]&0xFE;
	lds R24,_Uadc9
	andi R24,254
	out 0x1b,R24
	.dbline 178
; 		  portb1 = Uadc9&0x01;//privet[ukaz+8]&0x01;
	lds R24,_Uadc9
	andi R24,1
	sts _portb1,R24
	.dbline 179
; 		  PORTB = portb1|0x16;		  
	ori R24,22
	out 0x18,R24
	.dbline 180
; 		  break;	   
	xjmp L23
L28:
	.dbline 182
; 	   case 4:	      
; 		  PORTD = Uadc10;//privet[ukaz+9];
	lds R2,_Uadc10
	out 0x12,R2
	.dbline 183
; 		  PORTC = Uadc11;//privet[ukaz+10];
	lds R2,_Uadc11
	out 0x15,R2
	.dbline 184
; 		  PORTA = Uadc12&0xFE;//privet[ukaz+11]&0xFE;
	lds R24,_Uadc12
	andi R24,254
	out 0x1b,R24
	.dbline 185
; 		  portb1 = Uadc12&0x01;//privet[ukaz+11]&0x01;
	lds R24,_Uadc12
	andi R24,1
	sts _portb1,R24
	.dbline 186
; 		  PORTB = portb1|0x0E;
	ori R24,14
	out 0x18,R24
	.dbline 187
; 		  N = 0;		  
	clr R2
	sts _N,R2
	.dbline 188
; 		  break;	    	  	   
L22:
L23:
	.dbline -2
L21:
	.dbline 0 ; func end
	ret
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\ANALIZ~2\code\adc.c
_Uadc12::
	.blkb 1
	.dbsym e Uadc12 _Uadc12 c
_Uadc11::
	.blkb 1
	.dbsym e Uadc11 _Uadc11 c
_Uadc10::
	.blkb 1
	.dbsym e Uadc10 _Uadc10 c
_Uadc9::
	.blkb 1
	.dbsym e Uadc9 _Uadc9 c
_Uadc8::
	.blkb 1
	.dbsym e Uadc8 _Uadc8 c
_Uadc7::
	.blkb 1
	.dbsym e Uadc7 _Uadc7 c
_Uadc6::
	.blkb 1
	.dbsym e Uadc6 _Uadc6 c
_Uadc5::
	.blkb 1
	.dbsym e Uadc5 _Uadc5 c
_Uadc4::
	.blkb 1
	.dbsym e Uadc4 _Uadc4 c
_Uadc2::
	.blkb 1
	.dbsym e Uadc2 _Uadc2 c
_Uadc3::
	.blkb 1
	.dbsym e Uadc3 _Uadc3 c
_Uadc1::
	.blkb 1
	.dbsym e Uadc1 _Uadc1 c
_Uadc::
	.blkb 1
	.dbsym e Uadc _Uadc c
_buffer_ukaz::
	.blkb 2
	.dbsym e buffer_ukaz _buffer_ukaz pc
_buffer::
	.blkb 512
	.dbsym e buffer _buffer A[512:512]c
_N::
	.blkb 1
	.dbsym e N _N c
_value::
	.blkb 1
	.dbsym e value _value c
; 	}		   
; }
; 
; 
; 
; 
