//ICC-AVR application builder : 11.03.2009 10:09:26
// Target : M16
// Crystal: 16.0000Mhz

#include <iom16v.h>
#include <macros.h>
#include "math.h"

unsigned char value;

unsigned short countStolb = 15;
unsigned short countStlbTek = 0;

unsigned char countVD = 128;
unsigned char count = 0;
unsigned char N;
volatile unsigned char f_adc = 0;
unsigned char Regim = 0;
unsigned short RegimCount = 600;
unsigned short RegimCountTek = 0;

unsigned char buffer[512];
unsigned short countBuf = 0;
unsigned short countFIR = 512;

const char text[510] =  {0xFF, 0xFF, 0xFF,
                         0xFF, 0xFF, 0xFF,
                         0xFF, 0xFF, 0xFF,
                         0xFF, 0xFF, 0xFF, 
                         0xFB, 0x7D, 0x03, 0x7F, 0x01, 0xFF,//
                         0x01, 0x6D, 0x6D, 0x6D, 0x7D, 0xFF,//E
				         0x01, 0xEF, 0xEF, 0xEF, 0x01, 0xFF,//
				         0x81, 0x77, 0x77, 0x77, 0x81, 0xFF,//
				         0xFF, 0xFD, 0xFC, 0xFF, 0xFF, 0xFF,//,				   
				         0x01, 0x7F, 0x7F, 0x7F, 0x01, 0xFF,//
						 0x83, 0x7D, 0x7D, 0x7D, 0x83, 0xFF,//O
				         0x7D, 0x6D, 0x6D, 0x6D, 0x93, 0xFF,//
						 0xF1, 0x6B, 0x1B, 0x7B, 0x01, 0xFF,//
						 0x01, 0x77, 0x77, 0x77, 0x8F, 0xFF,//
						 0x81, 0x77, 0x77, 0x77, 0x81, 0xFF,//
						 0x01, 0x6D, 0x6D, 0x6D, 0x93, 0xFF,//B
						 0xFB, 0x7D, 0x03, 0x7F, 0x01, 0xFF,//
						 0x9D, 0x6B, 0x67, 0x6F, 0x01, 0xFF,//
						 0x01, 0xEF, 0x83, 0x7D, 0x83, 0xFF,//
						 0xFF, 0xFF, 0xFF, 
						 0x83, 0x7D, 0x7D, 0x7D, 0xBB, 0xFF,//C
						 0xFF, 0xFF, 0xFF, 
						 0x93, 0x6D, 0x6D, 0x6D, 0x93, 0xFF,//8
						 0xFF, 0xFF, 0xFF, 
						 0x01, 0xBF, 0xCF, 0xBF, 0x01, 0xFF,//M
						 0x81, 0x77, 0x77, 0x77, 0x81, 0xFF,//
						 0x01, 0x77, 0x77, 0x77, 0x8F, 0xFF,//
						 0x7F, 0x7F, 0x01, 0x7F, 0x7F, 0xFF,//T
						 0x81, 0x77, 0x77, 0x77, 0x81, 0xFF,//
						 0xFF, 0xFF, 0x05, 0x05, 0xFF, 0xFF,//!						 
						 0xFF, 0xFF, 0xFF,
						 0x87, 0x03, 0x01, 0x80, 0xC0, 0x80, 0x01, 0x03, 0x87, //
						 0xFF, 0xFF, 0xFF,
						 0x11, 0xEF, 0x01, 0xEF, 0x11, 0xFF,//       
						 0x01, 0x6D, 0x6D, 0x6D, 0x7D, 0xFF,//E
						 0xFB, 0x7D, 0x03, 0x7F, 0x01, 0xFF,//
						 0x81, 0x77, 0x77, 0x77, 0x81, 0xFF,//
						 0x01, 0xEF, 0x83, 0x7D, 0x83, 0xFF,//
						 0xFF, 0xFF, 0xFF,
						 0x39, 0xD7, 0xEF, 0xD7, 0x39, 0xFF,//
						 0x83, 0x7D, 0x7D, 0x7D, 0x83, 0xFF,//O
						 0x01, 0x77, 0x77, 0x77, 0x8F, 0xFF,//
						 0x83, 0x7D, 0x7D, 0x7D, 0x83, 0xFF,//O
						 0x01, 0xFD, 0x01, 0xFD, 0x01, 0xFF,//
						 0x01, 0x6D, 0x6D, 0x6D, 0x7D, 0xFF,//E
						 0x01, 0x7F, 0x7F, 0x7F, 0x3F, 0xFF,//
						 0x83, 0x7D, 0x7D, 0x7D, 0x83, 0xFF,//O
						 0xFF, 0xFF, 0xFF,
						 0x01, 0xEF, 0xEF, 0xEF, 0x01, 0xFF,//
						 0x81, 0x77, 0x77, 0x77, 0x81, 0xFF,//
						 0x83, 0x7D, 0x7D, 0x7D, 0xBB, 0xFF,//C
						 0x7F, 0x7F, 0x01, 0x7F, 0x7F, 0xFF,//T
						 0x01, 0x77, 0x77, 0x77, 0x8F, 0xFF,//
						 0x83, 0x7D, 0x7D, 0x7D, 0x83, 0xFF,//O
						 0x01, 0x6D, 0x6D, 0x6D, 0x7D, 0xFF,//E
						 0x01, 0xEF, 0xEF, 0xEF, 0x01, 0xFF,//
						 0x01, 0xF7, 0xEF, 0xDF, 0x01, 0xFF,//
						 0x9D, 0x6B, 0x67, 0x6F, 0x01, 0xFF,//
						 0xFF, 0xFD, 0xFC, 0xFF, 0xFF, 0xFF,//,
						 0x1D, 0xEB, 0xF7, 0xEF, 0x1F, 0xFF,//
						 0xF1, 0x6B, 0x1B, 0x7B, 0x01, 0xFF,//
						 0x81, 0x77, 0x77, 0x77, 0x81, 0xFF,//
						 0x1F, 0xEF, 0xEF, 0xEF, 0x01, 0xFF,//
						 0x01, 0xF7, 0xEF, 0xDF, 0x01, 0xFF,//
						 0xFF, 0xFF, 0xFF,
						 0x01, 0xF7, 0xEF, 0xDF, 0x01, 0xFF,//
						 0xFF, 0xFF, 0xFF,
						 0x01, 0xEF, 0xEF, 0xEF, 0x01, 0xFF,//
						 0x81, 0x77, 0x77, 0x77, 0x81, 0xFF,//
						 0x01, 0xF7, 0x6F, 0xDF, 0x01, 0xFF,//
						 0x7F, 0x7F, 0x01, 0x7F, 0x7F, 0xFF,//T
						 0x01, 0xF7, 0xEF, 0xDF, 0x01, 0xFF,//
						 0xFF, 0xFF, 0xFF,
						 0xFB, 0x7D, 0x03, 0x7F, 0x01, 0xFF,//
						 0x01, 0xEF, 0x83, 0x7D, 0x83, 0xFF,//
						 0x01, 0x6D, 0x6D, 0x6D, 0x33, 0xFF,//
						 0x01, 0xF7, 0xEF, 0xDF, 0x01, 0xFF,//
						 0x01, 0xBF, 0xCF, 0xBF, 0x01, 0xFF,//M
						 0x1D, 0xEB, 0xF7, 0xEF, 0x1F, 0xFF,//
						 0x01, 0xEF, 0x83, 0x7D, 0x83, 0xFF,//
						 0xFF, 0xFF, 0xFF,
						 0x01, 0x77, 0x77, 0x77, 0x8F, 0xFF,//
						 0x81, 0x77, 0x77, 0x77, 0x81, 0xFF,//
						 0x01, 0x6D, 0x6D, 0x6D, 0x33, 0xFF,//
						 0x83, 0x7D, 0x7D, 0x7D, 0x83, 0xFF,//O
						 0x7F, 0x7F, 0x01, 0x7F, 0x7F, 0xFF,//T
						 0x1D, 0xEB, 0xF7, 0xEF, 0x1F, 0xFF,//
						 0xFF, 0xFF, 0x05, 0x05, 0xFF, 0xFF,//!	
						 0xFF, 0xFF, 0xFF,
						 0xC3, 0x81, 0x28, 0x04, 0x04, 0x28, 0x81, 0xC3, //
						 0xFF, 0xFF, 0xFF,                         
						 0xFF, 0xFF, 0xFF,
                         0xFF, 0xFF, 0xFF,
                         0xFF, 0xFF, 0xFF};
char ukaz=0;				   
unsigned int countStr = 3;
unsigned int countStrTek = 0;
char portb1 = 0;

unsigned char tmp, I, tmpVD, Y;
unsigned short ukaz_text;

int Re1, Lm1, Re2;
long int Re3, Lm3;
unsigned char f_fir = 0;
unsigned char firN = 0;
unsigned char ugol1, ugol2;
unsigned char Uadc;

volatile unsigned char VideoRam[24] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF , 0xFF, 0xFF, 0xFF, 0xFF,
                                       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF , 0xFF, 0xFF, 0xFF, 0xFF};  
volatile unsigned char Ram_ukaz = 0;
unsigned char countRam = 4;
unsigned char countRamTek = 0;
unsigned char f_dynamic = 0;
unsigned char Uadc1, Uadc2, Uadc3, Uadc4, Uadc5, Uadc6, Uadc7, Uadc8, Uadc9, Uadc10, Uadc11, Uadc12;

volatile unsigned char Ustolb[12];

volatile unsigned char f_down[12] = {0}; 
volatile unsigned char count_down[12] = {0};
unsigned short result1, result_Volt;
unsigned short i=0, j=0;
unsigned char smech = 0;
unsigned long summ;

unsigned char LOGdft1[10]     = {120, 22, 15, 11, 9, 6, 5, 4, 3, 0};
unsigned char linVD[9]        = {0xFF, 0xFE, 0xFC, 0xF8, 0xF0, 0xE0, 0xC0, 0x80, 0x00};  
unsigned char linVDdown[9]    = {0xFF, 0x7F, 0x3F, 0x1F, 0x0F, 0x07, 0x03, 0x01, 0x00};
unsigned char linVDtoch[9]    = {0xFF, 0xFE, 0xFC, 0xFA, 0xF6, 0xEE, 0xDE, 0xBE, 0x7E};
unsigned char linVDpolocka2[9]= {0xFF, 0xFE, 0xFC, 0xF8, 0xE1, 0xC3, 0x1F, 0x3F, 0x7F};
unsigned char linVDpolocka3[9]= {0xFF, 0xEF, 0xE7, 0xC3, 0x81, 0x00, 0x18, 0x3C, 0x7E};

unsigned char porogVD = 3;
volatile unsigned char f_VDperecl = 0;
volatile unsigned char VDPerecl = 0;
unsigned char ADC_ads[9] = {255, 224, 192, 160, 128, 96, 64, 32, 0}; //{0, 12, 24, 36, 48, 60, 72, 84, 96, 255};
unsigned char ADC_adsVD[8]= {0xFE, 0xFD, 0xFB, 0xF7, 0xEF, 0xDF, 0xBF, 0x7F};
unsigned char ADC_VD;


const signed char
     cos256[256] = {127,126,126,126,126,126,125,125,124,123,123,122,121,120,119,118,117,116,114,113,112,110,108,
		            107,105,103,102,100,98,96,94,91,89,87,85,82,80,78,75,73,70,67,65,62,59,57,54,51,48,45,42,39,36,
					33,30,27,24,21,18,15,12,9,6,3,0,-3,-6,-9,-12,-15,-18,-21,-24,-27,-30,-33,-36,-39,-42,-45,-48,-51,
					-54,-57,-59,-62,-65,-67,-70,-73,-75,-78,-80,-82,-85,-87,-89,-91,-94,-96,-98,-100,-102,-103,-105,
					-107,-108,-110,-112,-113,-114,-116,-117,-118,-119,-120,-121,-122,-123,-123,-124,-125,-125,-126,
					-126,-126,-126,-126,-127,-126,-126,-126,-126,-126,-125,-125,-124,-123,-123,-122,-121,-120,-119,
					-118,-117,-116,-114,-113,-112,-110,-108,-107,-105,-103,-102,-100,-98,-96,-94,-91,-89,-87,-85,-82,
					-80,-78,-75,-73,-70,-67,-65,-62,-59,-57,-54,-51,-48,-45,-42,-39,-36,-33,-30,-27,-24,-21,-18,-15,
					-12,-9,-6,-3,0,3,6,9,12,15,18,21,24,27,30,33,36,39,42,45,48,51,54,57,59,62,65,67,70,73,75,78,80,
					82,85,87,89,91,94,96,98,100,102,103,105,107,108,110,112,113,114,116,117,118,119,120,121,122,123,
					123,124,125,125,126,126,126,126,126};
const signed char
     sin256[256] = {0,3,6,9,12,15,18,21,24,27,30,33,36,39,42,45,48,51,54,57,59,62,65,67,70,73,75,78,80,82,85,87,89,
	                91,94,96,98,100,102,103,105,107,108,110,112,113,114,116,117,118,119,120,121,122,123,123,124,125,
					125,126,126,126,126,126,127,126,126,126,126,126,125,125,124,123,123,122,121,120,119,118,117,116,
					114,113,112,110,108,107,105,103,102,100,98,96,94,91,89,87,85,82,80,78,75,73,70,67,65,62,59,57,54,
					51,48,45,42,39,36,33,30,27,24,21,18,15,12,9,6,3,0,-3,-6,-9,-12,-15,-18,-21,-24,-27,-30,-33,-36,
					-39,-42,-45,-48,-51,-54,-57,-59,-62,-65,-67,-70,-73,-75,-78,-80,-82,-85,-87,-89,-91,-94,-96,-98,
					-100,-102,-103,-105,-107,-108,-110,-112,-113,-114,-116,-117,-118,-119,-120,-121,-122,-123,-123,
					-124,-125,-125,-126,-126,-126,-126,-126,-127,-126,-126,-126,-126,-126,-125,-125,-124,-123,-123,
					-122,-121,-120,-119,-118,-117,-116,-114,-113,-112,-110,-108,-107,-105,-103,-102,-100,-98,-96,-94,
					-91,-89,-87,-85,-82,-80,-78,-75,-73,-70,-67,-65,-62,-59,-57,-54,-51,-48,-45,-42,-39,-36,-33,-30,
					-27,-24,-21,-18,-15,-12,-9,-6,-3};
const signed char
     cos128[128] = {127,126,126,125,124,123,121,119,117,114,112,108,105,102,98,94,89,85,80,75,70,65,59,54,48,42,36,
	                30,24,18,12,6,0,-6,-12,-18,-24,-30,-36,-42,-48,-54,-59,-65,-70,-75,-80,-85,-89,-94,-98,-102,-105,
					-108,-112,-114,-117,-119,-121,-123,-124,-125,-126,-126,-127,-126,-126,-125,-124,-123,-121,-119,
					-117,-114,-112,-108,-105,-102,-98,-94,-89,-85,-80,-75,-70,-65,-59,-54,-48,-42,-36,-30,-24,-18,
					-12,-6,0,6,12,18,24,30,36,42,48,54,59,65,70,75,80,85,89,94,98,102,105,108,112,114,117,119,121,
					123,124,125,126,126};
const signed char
     sin128[128] = {0,6,12,18,24,30,36,42,48,54,59,65,70,75,80,85,89,94,98,102,105,108,112,114,117,119,121,123,124,
	                125,126,126,127,126,126,125,124,123,121,119,117,114,112,108,105,102,98,94,89,85,80,75,70,65,59,
					54,48,42,36,30,24,18,12,6,0,-6,-12,-18,-24,-30,-36,-42,-48,-54,-59,-65,-70,-75,-80,-85,-89,-94,
					-98,-102,-105,-108,-112,-114,-117,-119,-121,-123,-124,-125,-126,-126,-127,-126,-126,-125,-124,
					-123,-121,-119,-117,-114,-112,-108,-105,-102,-98,-94,-89,-85,-80,-75,-70,-65,-59,-54,-48,-42,
					-36,-30,-24,-18,-12,-6};
const signed char
     cos64[64] = {127,126,124,121,117,112,105,98,89,80,70,59,48,36,24,12,0,-12,-24,-36,-48,-59,-70,-80,-89,-98,-105,
	             -112,-117,-121,-124,-126,-127,-126,-124,-121,-117,-112,-105,-98,-89,-80,-70,-59,-48,-36,-24,-12,0,
				  12,24,36,48,59,70,80,89,98,105,112,117,121,124,126};
const signed char
     sin64[64] = {0,12,24,36,48,59,70,80,89,98,105,112,117,121,124,126,127,126,124,121,117,112,105,98,89,80,70,59,
	              48,36,24,12,0,-12,-24,-36,-48,-59,-70,-80,-89,-98,-105,-112,-117,-121,-124,-126,-127,-126,-124,
				  -121,-117,-112,-105,-98,-89,-80,-70,-59,-48,-36,-24,-12};	
const signed char
     cos48[48] = {127,125,122,117,109,100,89,77,63,48,32,16,0,-16,-32,-48,-63,-77,-89,-100,-109,-117,-122,-125,-127,
	              -125,-122,-117,-109,-100,-89,-77,-63,-48,-32,-16,0,16,32,48,63,77,89,100,109,117,122,125};

const signed char
     sin48[48] = {0,16,32,48,63,77,89,100,109,117,122,125,127,125,122,117,109,100,89,77,63,48,32,16,0,-16,-32,-48,
	              -63,-77,-89,-100,-109,-117,-122,-125,-127,-125,-122,-117,-109,-100,-89,-77,-63,-48,-32,-16};

const signed char
     cos36[36] = {127,125,119,109,97,81,63,43,22,0,-22,-43,-63,-81,-97,-109,-119,-125,-127,-125,-119,-109,-97,-81,
	 -63,-43,-22,0,22,43,63,81,97,109,119,125};

const signed char
     sin36[36] = {0,22,43,63,81,97,109,119,125,127,125,119,109,97,81,63,43,22,0,-22,-43,-63,-81,-97,-109,-119,-125,
	 -127,-125,-119,-109,-97,-81,-63,-43,-2};

const signed char
     cos32[32] = {127,124,117,105,89,70,48,24,0,-24,-48,-70,-89,-105,-117,-124,-127,-124,-117,-105,-89,-70,-48,-24,
	 0,24,48,70,89,105,117,124};

const signed char
     sin32[32] = {0,24,48,70,89,105,117,124,127,124,117,105,89,70,48,24,0,-24,-48,-70,-89,-105,-117,-124,-127,-124,
	 -117,-105,-89,-70,-48,-24};

const signed char
     cos24[24] = {127,122,109,89,63,32,0,-32,-63,-89,-109,-122,-127,-122,-109,-89,-63,-32,0,32,63,89,109,122};

const signed char
     sin24[24] = {0,32,63,89,109,122,127,122,109,89,63,32,0,-32,-63,-89,-109,-122,-127,-122,-109,-89,-63,-32};

const signed char
     cos16[16] = {127,117,89,48,0,-48,-89,-117,-127,-117,-89,-48,0,48,89,117};
const signed char
     sin16[16] = {0,48,89,117,127,117,89,48,0,-48,-89,-117,-127,-117,-89,-48};	 
	 
const signed char
     cos12[12] = {127,109,63,0,-63,-109,-127,-109,-63,0,63,109};
const signed char
     sin12[12] = {0,63,109,127,109,63,0,-63,-109,-127,-109,-63};
	 
const signed char
     cos8[8] = {127,89,0,-89,-127,-89,0,89};
const signed char
     sin8[8] = {0,89,127,89,0,-89,-127,-89};

const signed char
     cos4[4] = {127,0,-127,0};
const signed char
     sin4[4] = {0,127,0,-127};
				  				
int sumLm,sumRe; 
unsigned short iF; 				   
//call this routine to initialize all peripherals
void init_devices(void)
{
 //stop errant interrupts until set up
 CLI(); //disable all interrupts
 //  
 DDRA  = 0xFE;
 PORTA = 0x00; 
 DDRB  = 0xFF;
 PORTB = 0x1C; 
 PORTC = 0x00; //m103 output only
 DDRC  = 0xFF;
 DDRD  = 0xFF;
 PORTD = 0x00;//0x40; 
 //   : 52 uS 19.2 
 ADCSR = 0x00; //disable adc
 ADMUX = 0x20; //select adc input 0 //    
 ACSR  = 0x80;
 ADCSR = 0xEE; //0xCD; 

 MCUCR = 0x12; 
 GICR  = 0x00;
 TIMSK = 0x00; //timer interrupt sources
 SEI(); //re-enable interrupts
 //all peripherals are now initialized 
 asm("sleep"); //    ,     
}

//
void main(void)
{
 init_devices();
 //insert your functional code here... 
 while(1)
 {
    while(f_adc==0);   
   	
	if(Regim == 9)
	{
	   if(countStrTek == countStr)
       {
	      text_to_ram();
          ukaz_text++;		  
	      if(ukaz_text == 498)
	         ukaz_text = 0;
	      countStrTek = 0;
       } 
       else
          countStrTek++;	       	  	  
    }
	else
	{
	   //----------------- 
	   Uolsh1();
	   Uolsh2();
	   Uolsh3();
	   Uolsh4();	
	   Uolsh5();
	   Uolsh6();
	   Uolsh7();
	   Uolsh8();  //  1,2 
	   Uolsh9();
	   Uolsh10();
	   Uolsh11();			  		
       Uolsh12();	
	} 	
		
	f_adc=0;	
	MCUCR = 0x12;    //        
    asm("sleep");	 //           
  } 
}

#pragma interrupt_handler timer0_ovf_isr:10
void timer0_ovf_isr(void)
{
  TCNT0 = 0xB0; //reload counter value   
}


//     19.2kHz
#pragma interrupt_handler adc_isr:15
void adc_isr(void)
{
 //conversion complete, read value (int) using...
 //value = ADCL>>2;            //Read 8 low bits first (important)
 //value = ADCH<<6;
 value = ADCL;            //Read 8 low bits first (important)
 value = ADCH;  
 count++; 
  
 if(count==countVD)           // 
 { 
    count = 0;
	countStlbTek++;
	if(countStlbTek == countStolb)//  
    {  
       countStlbTek = 0;
	
       RegimCountTek++;
	   if(RegimCountTek == RegimCount)
	   {
	      RegimCountTek=0;	 
	      if(Regim == 9)
		  {  
		     Regim = 0;			 		
			 countStrTek = 0;
			 ukaz_text = 0;			 
			 
		  }
		  else	  
		     Regim++;
	   }
	   switch(Regim)
	   {
	      case 1:
		  case 7:
		     StolbDown(0);
	         StolbDown(1);
	         StolbDown(2);
	         StolbDown(3);
	         StolbDown(4); 
	         StolbDown(5);
	         StolbDown(6);
	         StolbDown(7);
	         StolbDown(8); 
	         StolbDown(9); 	
	         StolbDown(10);	      
		     StolbDown(11); 
			 break;
	      case 2:
		     StolbDownUp(0);
			 StolbDownUp(1);
			 StolbDownUp(2);
			 StolbDownUp(3);	
			 StolbDownUp(4);
			 StolbDownUp(5);
			 StolbDownUp(6);
			 StolbDownUp(7);
			 StolbDownUp(8);
			 StolbDownUp(9);
			 StolbDownUp(10);
			 StolbDownUp(11);
			 break;	 
		  case 5:
		     StolbDownUpMini(0);
			 StolbDownUpMini(1);
			 StolbDownUpMini(2);
			 StolbDownUpMini(3);
			 StolbDownUpMini(4);
			 StolbDownUpMini(5);
			 StolbDownUpMini(6);
			 StolbDownUpMini(7);
			 StolbDownUpMini(8);
			 StolbDownUpMini(9);
			 StolbDownUpMini(10);
			 StolbDownUpMini(11);
			 StolbDownUpMini(12);
			 break;	 
	   }	   
	   
    }
	VD_select(); 
 }	
 if(f_adc == 0)               //      
 {
    buffer[countBuf] = value;
    countBuf++; 
  
    if(countBuf==countFIR)    //     
    {
       countBuf=0;
	   f_adc=1;	      	 	  //        
    } 
    else
    { 
       MCUCR = 0x12;          //    ,       
       asm("sleep");
    }
 }
   
}

void adc_interrupt(void)
{
   if(ADCSR&0x10)
   {
      count++;
      if(count==countVD)           // 
      { 
         count = 0;		
         VD_select(); 
      }	
   }   
}

//     
void text_to_ram(void)
{
   Y = 0;
   do
   {
       VideoRam[Y] = text[Y+ukaz_text];
	   Y++;
   }
   while(Y < 12);
}

//---------------------  
void VD_select(void)
{
    N++;
    switch(N)
	{
	   case 1:
	      //PORTB = 0x1C;
		  PORTD = VideoRam[0];//Uadc1;//privet[ukaz];
		  PORTC = VideoRam[1];//Uadc2;//privet[ukaz+1];
		  PORTA = VideoRam[2]&0xFE;//Uadc3&0xFE;//privet[ukaz+2]&0xFE;
		  portb1 = VideoRam[2]&0x01;//Uadc3&0x01;//privet[ukaz+2]&0x01;
		  PORTB = portb1|0x1C;			  
		  break;	      
	   case 2:
	      PORTD = VideoRam[3];//Uadc4;//privet[ukaz+3];
		  PORTC = VideoRam[4];//Uadc5;//privet[ukaz+4];
		  PORTA = VideoRam[5]&0xFE;//Uadc6&0xFE;//privet[ukaz+5]&0xFE;
		  portb1 = VideoRam[5]&0x01;//Uadc6&0x01;//privet[ukaz+5]&0x01;
		  PORTB = portb1|0x1A;	
		  break;
	   case 3:
	      PORTD = VideoRam[6];//Uadc7;//privet[ukaz+6];
		  PORTC = VideoRam[7];//Uadc8;//privet[ukaz+7];
		  PORTA = VideoRam[8]&0xFE;//Uadc9&0xFE;//privet[ukaz+8]&0xFE;
		  portb1 = VideoRam[8]&0x01;//Uadc9&0x01;//privet[ukaz+8]&0x01;
		  PORTB = portb1|0x16;		  
		  break;	   
	   case 4:	      
		  PORTD = VideoRam[9];//Uadc10;//privet[ukaz+9];
		  PORTC = VideoRam[10];//Uadc11;//privet[ukaz+10];
		  PORTA = VideoRam[11]&0xFE;//Uadc12&0xFE;//privet[ukaz+11]&0xFE;
		  portb1 = VideoRam[11]&0x01;//Uadc12&0x01;//privet[ukaz+11]&0x01;
		  PORTB = portb1|0x0E;
		  N = 0;		  
		  break;	    	  	   
	}		   
}

//---------       
unsigned short isqrt(unsigned int from)
 {
   unsigned int mask = 0x4000, sqr = 0, temp;
   do {
        temp = sqr | mask;
        sqr >>= 1;
        if( temp <= from )
        {
            sqr |= mask;
            from -= temp;
        }
		adc_interrupt(); 
     }
     while( mask >>= 2 );
     //     if( sqr < from ) ++sqr;
     return (unsigned short)sqr;
 }


//    9,6        
// , .      ,     
//  90 ,      , .    
//   0-  
void Uolsh12(void)
{
    Re1 = Re2 = i = ugol2 = 0;	   
	ugol1 = 1;
	i=0;	
	do
	{	
	   adc_interrupt(); 	     
	   //  
	   if(i == ugol1)
	      Re1 = Re1 - buffer[i]; 
	   else
	      Re1 = Re1 + buffer[i];
	   if(i == ugol2)
	      Re2 = Re2 - buffer[i]; 
	   else
	      Re2 = Re2 + buffer[i]; 
	   
	   if(i == ugol1)
       {  ugol1 = ugol1 + 2;
	      ugol2 = ugol2 + 2;
	   }	    
	   i++; 	
	}
	while(i < 16);  	
	    
	//  
	//   	
	if(Re1 > Re2)
	   result1 = Re1>>4; //    16 
	else
	   result1 = Re2>>4; //    16      	
	//   20 	
	result_Volt = 9;
    i=0;
	do
	{
	   adc_interrupt(); 
	   result_Volt--;
       if(result1 <= LOGdft1[i] && result1 >= LOGdft1[i+1])
           break;
	   i++;	   
	}
	while(i<9);	
	
	//        
	 VDshow1(11, 11, result_Volt, 0x001);       
	   
}


//    4,8  
void Uolsh11(void)
{
    Uadc = FurieFunc(2, 32, 4, 12);	 
	VDshow2(10, 10,  Uadc, 0x002);		        	      
}


//    2,4  
void Uolsh10(void)
{
    Uadc = FurieFunc(3, 32, 8, 12);	   
	VDshow1(9, 9, Uadc, 0x004);	       	   	       
} 
 
//    1,6  
void Uolsh9(void)
{
    Uadc = FurieFunc(4, 60, 12, 13);
	VDshow2(8, 8, Uadc, 0x008);		      
}
 
//    1,2  
void Uolsh8(void)
{
    Uadc = FurieFunc(5, 64, 16, 13);
	VDshow1(7, 7, Uadc, 0x010); 	  
} 

//    800  
void Uolsh7(void)
{
   Uadc = FurieFunc(6, 240, 24, 15);
   VDshow2(6, 6, Uadc, 0x020);	   	     	          
} 

//    600  
void Uolsh6(void)
{
    Uadc = FurieFunc(7, 256, 32, 15);	   
	VDshow1(5, 5, Uadc, 0x040);		        
} 


//    500  
void Uolsh5(void)
{
    Uadc = FurieFunc(8, 252, 36, 15);
	VDshow2(4, 4, Uadc, 0x080);	 	   
}

//    400  
void Uolsh4(void)
{
    Uadc = FurieFunc(9, 240, 48, 15);
	VDshow1(3, 3, Uadc, 0x100);	     	  
}

//    300  
void Uolsh3(void)
{
    Uadc = FurieFunc(10, 512, 64, 16);
	VDshow2(2, 2, Uadc, 0x200); 
}

//    150  
void Uolsh2(void)
{
    Uadc = FurieFunc(11, 512, 128, 16);
	VDshow1(1, 1, Uadc, 0x400);		      
}
 
//    75  
void Uolsh1(void)
{
    Uadc = FurieFunc(12, 512, 256, 16);
	VDshow2(0, 0,  Uadc, 0x800);   
}

void VDshow1(unsigned char ukaz_mas, unsigned char ukaz_ram, unsigned char Uabs,unsigned short VDmasTek)
{
   switch(Regim)
	{
	    case 0:  
		  VideoRam[ukaz_ram] = linVD[Uabs]; 
		  break;
		case 1:
		  VideoRam[ukaz_ram] = linVD[Uabs];
	      Stolb(ukaz_mas, ukaz_ram);             
		  break;
		case 2:
		  VideoRam[ukaz_ram] = linVDdown[Uabs];	
		  Stolb3Down(ukaz_mas, ukaz_ram);  
		  break;
		case 3:
		  VideoRam[ukaz_ram]= linVDtoch[Uabs];  
		  break; 	
		case 4:
		  EffectSnowADC(ukaz_ram,Uabs);
		  break;
		case 5: 
		  VideoRam[ukaz_ram] = linVD[Uabs];	       
		  Stolb3(ukaz_mas, ukaz_ram);
		  break;
		case 6: 
		  UadcShow();
		  break;  
		case 7: 
		  VideoRam[ukaz_ram] = linVD[Uabs];
	      Stolb2(ukaz_mas, ukaz_ram);  
		  break;	
		case 8:
	      VideoRam[ukaz_ram]= linVDpolocka3[Uabs];
		  break;		      		 		  	
	}     
}

void VDshow2(unsigned char ukaz_mas, unsigned char ukaz_ram, unsigned char Uabs,unsigned short VDmasTek)
{
   switch(Regim)
	{
	   case 0:    
	       VideoRam[ukaz_ram] = linVD[Uabs]; 
		   break;
	   case 1:
	       VideoRam[ukaz_ram] = linVD[Uabs];
	       Stolb(ukaz_mas, ukaz_ram);  
		   break;
	   case 2:
		   VideoRam[ukaz_ram] = linVD[Uabs]; 
		   Stolb3(ukaz_mas, ukaz_ram); 
		   break;   
	   case 3:
	       VideoRam[ukaz_ram] = linVDtoch[Uabs];
		   break;
	   case 4:
		  EffectSnowADC(ukaz_ram,Uabs); 			 
		  break;
	   case 5: 
		  VideoRam[ukaz_ram] = linVD[Uabs];	       
		  Stolb3(ukaz_mas, ukaz_ram);
		  break;  
	   case 6: 
		  UadcShow();
		  break;
	   case 7: 
		  VideoRam[ukaz_ram] = linVD[Uabs];
	      Stolb2(ukaz_mas, ukaz_ram);  
		  break;
	   case 8:
	      VideoRam[ukaz_ram]= linVDpolocka3[Uabs];
		  break;   	    	   	  	   		     	   
	}	 
}

//  
void UadcShow(void)
{
    Uadc = buffer[0];
	VideoRam[0] = UadcVD(Uadc);
	Uadc = buffer[46];
	VideoRam[1] = UadcVD(Uadc);
	Uadc = buffer[92];
	VideoRam[2] = UadcVD(Uadc);	
	Uadc = buffer[138];
	VideoRam[3] = UadcVD(Uadc);	
	Uadc = buffer[184];
	VideoRam[4] = UadcVD(Uadc);	
	Uadc = buffer[230];
	VideoRam[5] = UadcVD(Uadc);	
	Uadc = buffer[276];
	VideoRam[6] = UadcVD(Uadc);	
	Uadc = buffer[322];
	VideoRam[7] = UadcVD(Uadc);	
	Uadc = buffer[368];
	VideoRam[8] = UadcVD(Uadc);
	Uadc = buffer[414];
	VideoRam[9] = UadcVD(Uadc);	
	Uadc = buffer[460];
	VideoRam[10] = UadcVD(Uadc);	
	Uadc = buffer[511];
	VideoRam[11] = UadcVD(Uadc);		
}

//      
unsigned char UadcVD(unsigned char Uabs)
{
    i=0;
	result_Volt = 8;
	do
	{
	   adc_interrupt();
	   result_Volt--;	   
       if(Uabs <= ADC_ads[i] && Uabs >= ADC_ads[i+1])
          break;
	   i++; 	     
	}
	while(i<8);
	ADC_VD = ADC_adsVD[result_Volt];	
	return ADC_VD;
}

//    
void EffectSnowADC(unsigned char ukaz_ram, unsigned char Uabs)
{
          if(ukaz_ram == 0)
		  {
		     Uadc1 = 0xFF; Uadc2 = 0xFF;  Uadc3 = 0xFF;   Uadc4 = 0xFF;  Uadc5 = 0xFF;  Uadc6 = 0xFF;
			 Uadc7 = 0xFF; Uadc8 = 0xFF;  Uadc9 = 0xFF;   Uadc10 = 0xFF; Uadc11 = 0xFF; Uadc12 = 0xFF;
		  }		  
		  if(Uabs > porogVD)
		  {   
		     switch(ukaz_ram)
			 {
			     case 0:
				   Uadc1 = Uadc1&0xFE; Uadc3 = Uadc3&0xEF;   Uadc5 = Uadc5&0x7F;   Uadc6 = Uadc6&0xFD; 
				   Uadc8 = Uadc8&0xFD; Uadc10 = Uadc10&0xBF; Uadc11 = Uadc11&0xFD;
				   break;
				 case 1:
				   Uadc1 = Uadc1&0xEF; Uadc2 = Uadc2&0x7F;   Uadc3 = Uadc3&0xDF;   Uadc5 = Uadc5&0xF7; 
				   Uadc6 = Uadc6&0x7F; Uadc8 = Uadc8&0xFB;   Uadc10 = Uadc10&0xDF; Uadc12 = Uadc12&0xBF;
				   break; 
				 case 2:
				   Uadc2 = Uadc2&0xBF; Uadc4 = Uadc4&0xF7;   Uadc6 = Uadc6&0xBF;   Uadc7 = Uadc7&0xF7; 
				   Uadc8 = Uadc8&0x7F; Uadc10 = Uadc10&0xFB; Uadc12 = Uadc12&0xFE; 
				   break;  
				 case 3:
				   Uadc2 = Uadc2&0xF7; Uadc4 = Uadc4&0xFD;   Uadc5 = Uadc5&0xBF;   Uadc7 = Uadc7&0xEF; 
				   Uadc8 = Uadc8&0xBF; Uadc9 = Uadc9&0xFB;   Uadc11 = Uadc11&0xEF; Uadc12 = Uadc12&0xFD; 
				   break;
				 case 4:
				   Uadc1 = Uadc1&0x7F; Uadc2 = Uadc2&0xEF;   Uadc3 = Uadc3&0xBF;   Uadc4 = Uadc4&0xFB; 
				   Uadc5 = Uadc5&0xEF; Uadc6 = Uadc6&0xDF;   Uadc7 = Uadc7&0x7F;   Uadc8 = Uadc8&0xFE; 
				   Uadc10 = Uadc10&0x7F;Uadc12 = Uadc12&0xF7; 
				   break;  
				 case 5:
				   Uadc2 = Uadc2&0xFD; Uadc4 = Uadc4&0xEF;   Uadc5 = Uadc5&0xFD;   Uadc7 = Uadc7&0xDF; 
				   Uadc9 = Uadc9&0xF7; Uadc10 = Uadc10&0xFE;   Uadc12 = Uadc12&0xDF;   
				   break;  
				 case 6:
				   Uadc1 = Uadc1&0xDF; Uadc3 = Uadc3&0x7F;   Uadc4 = Uadc4&0xFE;   Uadc5 = Uadc5&0xDF; 
				   Uadc7 = Uadc7&0xBF; Uadc8 = Uadc8&0xF7;   Uadc9 = Uadc9&0xFE;   Uadc10 = Uadc10&0xEF; 
				   Uadc11 = Uadc11&0x7F;
				   break; 
				 case 7:
				   Uadc1 = Uadc1&0xFD; Uadc2 = Uadc2&0xDF;   Uadc3 = Uadc3&0xFE;   Uadc5 = Uadc5&0xFB; 
				   Uadc7 = Uadc7&0xFE; Uadc8 = Uadc8&0xEF;   Uadc9 = Uadc9&0x7F;   Uadc10 = Uadc10&0xFD; 
				   Uadc11 = Uadc11&0xBF;
				   break; 
				 case 8:
				   Uadc2 = Uadc2&0xFE; Uadc3 = Uadc3&0xF7;   Uadc4 = Uadc4&0x7F;   Uadc6 = Uadc6&0xEF; 
				   Uadc7 = Uadc7&0xFD; Uadc9 = Uadc9&0xDF;   Uadc11 = Uadc11&0xF7; Uadc12 = Uadc12&0x7F; 
				   break;   
				 case 9:
				   Uadc1 = Uadc1&0xBF; Uadc3 = Uadc3&0xFB;   Uadc4 = Uadc4&0xDF;   Uadc6 = Uadc6&0xFB; 
				   Uadc9 = Uadc9&0xBF; Uadc10 = Uadc10&0xF7; Uadc11 = Uadc11&0xDF; Uadc12 = Uadc12&0xFB; 
				   break;
				 case 10:
				   Uadc2 = Uadc2&0xFB; Uadc4 = Uadc4&0xBF;   Uadc5 = Uadc5&0xFE;   Uadc6 = Uadc6&0xF7; 
				   Uadc8 = Uadc8&0xFD; Uadc9 = Uadc9&0xEF;   Uadc11 = Uadc11&0xFE; Uadc12 = Uadc12&0xEF; 
				   break;
				 case 11:
				   Uadc1 = Uadc1&0xF7; Uadc3 = Uadc3&0xFD;   Uadc6 = Uadc6&0xFE;   Uadc7 = Uadc7&0xFB; 
				   Uadc9 = Uadc9&0xFD; Uadc11 = Uadc11&0xFB; 
				   break;                       
			 } 		  
		  }	
		  if(ukaz_ram == 11)
		  {
		     VideoRam[0] = Uadc1;  VideoRam[1] = Uadc2;  VideoRam[2] = Uadc3;   VideoRam[3] = Uadc4;
			 VideoRam[4] = Uadc5;  VideoRam[5] = Uadc6;  VideoRam[6] = Uadc7;   VideoRam[7] = Uadc8;
			 VideoRam[8] = Uadc9;  VideoRam[9] = Uadc10; VideoRam[10] = Uadc11; VideoRam[11] = Uadc12;
		  } 
}

//    
void StolbDown(unsigned char ukaz_mas)
{
   if(Ustolb[ukaz_mas] != 0xFF)
   {
      if(f_down[ukaz_mas] == 1)                       
      {  
	     tmp = ~Ustolb[ukaz_mas];
	     Ustolb[ukaz_mas] = ~(tmp>>1);
	  }
	  else
	  {
	     count_down[ukaz_mas]++;
		 if(count_down[ukaz_mas] == 10)
		 {
		    count_down[ukaz_mas] = 0;
		    f_down[ukaz_mas] = 1;			
		 }
	  }  	 
   }    
} 

//            
void Stolb(unsigned char ukaz_mas, unsigned char ukaz_ram)
{
   if(Ustolb[ukaz_mas] != 0xFF)
   {	  
	  if((Ustolb[ukaz_mas]|VideoRam[ukaz_ram]) != 0xFF)
      {   
	      Ustolb[ukaz_mas] = 0x7F;
		  f_down[ukaz_mas] = 0;
		  count_down[ukaz_mas] = 0;
	  }
	   	   
   }
   else
   {
      if(VideoRam[ukaz_ram] != 0xFF)
	  {  
	     Ustolb[ukaz_mas] = 0x7F;
		 f_down[ukaz_mas] = 0;
		 count_down[ukaz_mas] = 0;
	  }	     
   }
   VideoRam[ukaz_ram] = VideoRam[ukaz_ram]&Ustolb[ukaz_mas];
}

//           WinAmp-
void Stolb2(unsigned char ukaz_mas, unsigned char ukaz_ram)
{
   if(Ustolb[ukaz_mas] != 0xFF)
   {	  
	  if((Ustolb[ukaz_mas]|VideoRam[ukaz_ram]) != 0xFF)
      {   
	      StolbADC(ukaz_mas, ukaz_ram);		  
		  //Ustolb[ukaz_mas] = 0x7F;
		  f_down[ukaz_mas] = 0;
		  count_down[ukaz_mas] = 0;
	  }
	   	   
   }
   else
   {
      if(VideoRam[ukaz_ram] != 0xFF)
	  {  
	     //Ustolb[ukaz_mas] = 0x7F;
		 StolbADC(ukaz_mas, ukaz_ram);
		 f_down[ukaz_mas] = 0;
		 count_down[ukaz_mas] = 0;
	  }	     
   }
   VideoRam[ukaz_ram] = VideoRam[ukaz_ram]&Ustolb[ukaz_mas];
}

//    WinAmp-
void StolbADC(unsigned char ukaz_mas, unsigned char ukaz_ram)
{
   switch(VideoRam[ukaz_ram])
   {
	 case 0xFE:
		Ustolb[ukaz_mas] = 0xFE; break;
	 case 0xFC:
	    Ustolb[ukaz_mas] = 0xFD; break;	
	 case 0xF8:
	    Ustolb[ukaz_mas] = 0xFB; break; 	
	 case 0xF0:
		Ustolb[ukaz_mas] = 0xF7; break; 	
	 case 0xE0:
	    Ustolb[ukaz_mas] = 0xEF; break; 
	 case 0xC0:
	    Ustolb[ukaz_mas] = 0xDF; break; 	
	 case 0x80:
	    Ustolb[ukaz_mas] = 0xBF; break; 
	 case 0x00:
	    Ustolb[ukaz_mas] = 0x7F; break; 			 	 		 	 	  
   }
}


//          
void Stolb3(unsigned char ukaz_mas, unsigned char ukaz_ram)
{
   if(Ustolb[ukaz_mas] != 0xFF)
   {	  
	  if((Ustolb[ukaz_mas]|VideoRam[ukaz_ram]) != 0xFF)
      {   
	      StolbADC(ukaz_mas, ukaz_ram);	  
		  f_down[ukaz_mas] = 0;	
		  	 
	  }
	   	   
   }
   else
   {
      if(VideoRam[ukaz_ram] != 0xFF)
	  {  
	     StolbADC(ukaz_mas, ukaz_ram);
		 f_down[ukaz_mas] = 0;		 
	  }	     
   }
   VideoRam[ukaz_ram] = VideoRam[ukaz_ram]&Ustolb[ukaz_mas];
}

//       3
void StolbDownUpMini(unsigned char ukaz_mas)
{
   if(Ustolb[ukaz_mas] != 0xFF)
   {
      if(f_down[ukaz_mas] == 1)                       
      {  
	     tmp = ~Ustolb[ukaz_mas];
	     Ustolb[ukaz_mas] = ~(tmp>>1);
		 if(Ustolb[ukaz_mas] == 0xFE)
		    f_down[ukaz_mas] = 0;
	  }
      else
	  {
	     tmp = ~Ustolb[ukaz_mas];
	     Ustolb[ukaz_mas] = ~(tmp<<1);
		 if(Ustolb[ukaz_mas] == 0x7F)
		 {  
		    f_down[ukaz_mas] = 1;
			count_down[ukaz_mas] = 0;
		 }
		 else
		 {
		    count_down[ukaz_mas]++;
		    if(count_down[ukaz_mas] == 2)
		    {
		       count_down[ukaz_mas] = 0;
		       f_down[ukaz_mas] = 1;			
		    }
	     }		
	  }  	 
   } 
} 


//       
void StolbDownUp(unsigned char ukaz_mas)
{
   if(Ustolb[ukaz_mas] != 0xFF)
   {
      if(f_down[ukaz_mas] == 1)                       
      {  
	     tmp = ~Ustolb[ukaz_mas];
	     Ustolb[ukaz_mas] = ~(tmp>>1);
		 if(Ustolb[ukaz_mas] == 0xFE)
		    f_down[ukaz_mas] = 0;
	  }
      else
	  {
	     tmp = ~Ustolb[ukaz_mas];
	     Ustolb[ukaz_mas] = ~(tmp<<1);
		 if(Ustolb[ukaz_mas] == 0x7F)
		    f_down[ukaz_mas] = 1;			
	  }  	 
   } 
} 

//          
void Stolb3Down(unsigned char ukaz_mas, unsigned char ukaz_ram)
{
   if(Ustolb[ukaz_mas] != 0xFF)
   {	  
	  if((Ustolb[ukaz_mas]|VideoRam[ukaz_ram]) != 0xFF)
      {   
	      StolbADCDown(ukaz_mas, ukaz_ram);	  
		  f_down[ukaz_mas] = 1;	
		  	 
	  }
	   	   
   }
   else
   {
      if(VideoRam[ukaz_ram] != 0xFF)
	  {  
	     StolbADCDown(ukaz_mas, ukaz_ram);
		 f_down[ukaz_mas] = 1;		 
	  }	     
   }
   VideoRam[ukaz_ram] = VideoRam[ukaz_ram]&Ustolb[ukaz_mas];
}

// 
void StolbADCDown(unsigned char ukaz_mas, unsigned char ukaz_ram)
{
   switch(VideoRam[ukaz_ram])
   {
	 case 0x7F:
		Ustolb[ukaz_mas] = 0x7F; break;
	 case 0x3F:
	    Ustolb[ukaz_mas] = 0xBF; break;	
	 case 0x1F:
	    Ustolb[ukaz_mas] = 0xDF; break; 	
	 case 0x0F:
		Ustolb[ukaz_mas] = 0xEF; break; 	
	 case 0x07:
	    Ustolb[ukaz_mas] = 0xF7; break; 
	 case 0x03:
	    Ustolb[ukaz_mas] = 0xFD; break; 	
	 case 0x01:
	    Ustolb[ukaz_mas] = 0xFE; break; 		 	 		 	 	  
   }
}


//      
//N_filtr -  
//count   -     
//countiF -     
//del     -  .  128   7 64 - 6  . . 2   del  7(..   
//            128 )
unsigned char FurieFunc(unsigned char N_filtr,  unsigned short count, 
                        unsigned short countiF, unsigned char del)
{
    Re1 = Lm1 = 0;
	i=0;
	iF = 0;
	do
	{
	   adc_interrupt(); 	
	   //  , .   sin      0-180  1  -1
	   switch(N_filtr)
	   {
	       case 2:
		     sumLm = buffer[i]*sin4[iF];
	         sumRe = buffer[i]*cos4[iF];
			 break;	   
	       case 3:
		     sumLm = buffer[i]*sin8[iF];
	         sumRe = buffer[i]*cos8[iF];
			 break;	   
	       case 4:
		     sumLm = buffer[i]*sin12[iF];
	         sumRe = buffer[i]*cos12[iF];
			 break;		   
	      case 5:
		     sumLm = buffer[i]*sin16[iF];
	         sumRe = buffer[i]*cos16[iF];
			 break;	
	      case 6:
		     sumLm = buffer[i]*sin24[iF];
	         sumRe = buffer[i]*cos24[iF];
			 break;	
	      case 7:
		     sumLm = buffer[i]*sin32[iF];
	         sumRe = buffer[i]*cos32[iF];
			 break;	
	      case 8:
		     sumLm = buffer[i]*sin36[iF];
	         sumRe = buffer[i]*cos36[iF];
			 break;	
	      case 9:
		     sumLm = buffer[i]*sin48[iF];
	         sumRe = buffer[i]*cos48[iF];
			 break;	
	      case 10:
		     sumLm = buffer[i]*sin64[iF];
	         sumRe = buffer[i]*cos64[iF];
			 break;	   
	      case 11:
		     sumLm = buffer[i]*sin128[iF];
	         sumRe = buffer[i]*cos128[iF];
			 break;
	      case 12:	      
	         sumLm = buffer[i]*sin256[iF];
	         sumRe = buffer[i]*cos256[iF];
			 break;
	   }
	  
	   iF++;
	   if(iF == countiF)
		  iF=0;
	   Lm3 = Lm3 + sumLm;	   
	   Re3 = Re3 + sumRe;  
	   i++;	   
	}
	while(i<count);  	
	    
	//          	
	Re3 = Re3>>del; //    2   del
    Lm3 = Lm3>>del; //    2   del
    summ = Re3*Re3 + Lm3*Lm3;
	//   
	result1 = isqrt(summ);	
	//   20 	
	result_Volt = 9;
    i=0;
	do
	{
	    adc_interrupt();
	    result_Volt--;
        if(result1 <= LOGdft1[i] && result1 >= LOGdft1[i+1])
           break;
		i++;   
	}
	while(i<9);			
	
	//Uadc = linVD[result_Volt]; 
	return result_Volt;
} 