//ICC-AVR application builder : 11.03.2009 10:09:26
// Target : M16
// Crystal: 16.0000Mhz

#include <iom16v.h>
#include <macros.h>
#include "math.h"

unsigned char value;

unsigned short countStolb = 15;
unsigned short countStlbTek = 0;

unsigned char countVD = 128;
unsigned char count = 0;
unsigned char N;
volatile unsigned char f_adc = 0;
unsigned char Regim = 0;
unsigned short RegimCount = 300;
unsigned short RegimCountTek = 0;

unsigned char buffer[512];
unsigned short countBuf = 0;
unsigned short countFIR = 512;

const char text[202] =  {0xFF, 0xFF, 0xFF,
                         0xFF, 0xFF, 0xFF,
                         0xFF, 0xFF, 0xFF,
                         0xFF, 0xFF, 0xFF, 
                         0xFD, 0x83, 0xBF, 0x81, 0xFF,      //
                         0x81, 0xF7, 0x81, 0xBD, 0x81, 0xFF,//
				         0x81, 0xAD, 0xAD, 0xA1, 0xFF,      //
				         0x81, 0xBD, 0xBD, 0x81, 0xFF,      //
				         0x81, 0xAD, 0x8D, 0xE1, 0xFF,      //				   
				         0x81, 0xF5, 0xF1, 0xFF, 0xFF,      //
				         0x87, 0x03, 0x01, 0x80, 0xC0, 0x80, 0x01, 0x03, 0x87, 0xFF, //						 
						 0xFF, 0xFF, 0xFF,
						 0x81, 0xF7, 0xEF, 0x81, 0xFF,      //
						 0xFF, 0xFF, 0xFF,
						 0x85, 0xF5, 0xF5, 0x81, 0xFF,      //
						 0xF9, 0xC3, 0xBB, 0x83, 0xF9, 0xFF,//
						 0xC1, 0xB7, 0xB7, 0x81, 0xFF,      //
						 0x8F, 0xEF, 0xEF, 0x81, 0xFF,      //
						 0xC1, 0xB7, 0xB7, 0x81, 0xFF,      //
						 0xFF, 0xFF, 0xFF,
						 0x81, 0xDF, 0xEF, 0xDF, 0x81, 0xFF,//
						 0x81, 0xBD, 0xBD, 0x81, 0xFF,      // 
						 0x81, 0xF7, 0xEF, 0x81, 0xFF,      //
						 0xFF, 0xFF, 0xFF,                  //112
						 0x81, 0xAD, 0x8D, 0xE1, 0xFF,      //
						 0x81, 0xAD, 0xBD, 0xFF,            //
						 0x8F, 0xEF, 0x81, 0xFF,            //
						 0x81, 0xEF, 0xEF, 0x81, 0xFF,      //
						 0x81, 0xE5, 0xF1, 0x81, 0xFF,      //
						 0x81, 0xAD, 0xBD, 0xFF,            //						 
						 0xFF, 0xFF, 0xFF,
						 0x81, 0xBD, 0xBD, 0xFF,            //       
						 0x81, 0xBF, 0x81, 0xFF,            //
						 0x85, 0xF5, 0xF5, 0x81, 0xFF,      //
						 0xBF, 0x81, 0xBF, 0xFF,            //
						 0x81, 0xEF, 0xEF, 0x81, 0xFF,      //
						 0x81, 0xF7, 0xEF, 0x81, 0xFF,      //
						 0x81, 0xE7, 0xDB, 0xBD, 0xFF,      //
						 0x81, 0xF7, 0xEF, 0x81, 0xFF,      //
						 0xFF, 0xFF, 0xFF,                  //180
						 0xC3, 0x81, 0x28, 0x04, 0x04, 0x28, 0x81, 0xC3, //
						 0xFF, 0xFF, 0xFF,                         
						 0xFF, 0xFF, 0xFF,
                         0xFF, 0xFF, 0xFF,
                         0xFF, 0xFF, 0xFF};
char ukaz=0;				   
unsigned int countStr = 3;
unsigned int countStrTek = 0;
char portb1 = 0;

unsigned char tmp, I, tmpVD, Y;
unsigned char ukaz_text;

int Re1, Lm1, Re2;
unsigned char f_fir = 0;
unsigned char firN = 0;
unsigned char ugol1, ugol2;
unsigned char Uadc;

volatile unsigned char VideoRam[24] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF , 0xFF, 0xFF, 0xFF, 0xFF,
                                       0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF , 0xFF, 0xFF, 0xFF, 0xFF};  
volatile unsigned char Ram_ukaz = 0;
unsigned char countRam = 4;
unsigned char countRamTek = 0;
unsigned char f_dynamic = 0;


volatile unsigned char Ustolb[12];

volatile unsigned char f_down[12] = {0}; 
volatile unsigned char count_down[12] = {0};
unsigned short result1, result_Volt;
unsigned short i=0, j=0;
unsigned char smech = 0;
unsigned long summ;

unsigned char LOGdft1[10]     = {120, 22, 15, 11, 9, 6, 5, 4, 3, 0};
unsigned char linVD[9]        = {0xFF, 0xFE, 0xFC, 0xF8, 0xF0, 0xE0, 0xC0, 0x80, 0x00};  
unsigned char linVDdown[9]    = {0xFF, 0x7F, 0x3F, 0x1F, 0x0F, 0x07, 0x03, 0x01, 0x00};
unsigned char linVDtoch[9]    = {0xFF, 0xFE, 0xFC, 0xFA, 0xF6, 0xEE, 0xDE, 0xBE, 0x7E};
unsigned char linVDpolocka2[9]= {0xFF, 0xFE, 0xFC, 0xF8, 0xE1, 0xC3, 0x1F, 0x3F, 0x7F};
unsigned char linVDpolocka3[9]= {0xFF, 0xEF, 0xE7, 0xC3, 0x81, 0x00, 0x18, 0x3C, 0x7E};

unsigned char porogVD = 3;
volatile unsigned char f_VDperecl = 0;
volatile unsigned char VDPerecl = 0;
//unsigned short mas_VD[12] = {0x000, 0x801, 0xC03, 0xE07, 0xF0F, 0xF9F, 0xFFF, 0x7FE, 0x3FC, 0x1F8, 0x0F0, 0x060};

//call this routine to initialize all peripherals
void init_devices(void)
{
 //stop errant interrupts until set up
 CLI(); //disable all interrupts
 //  
 DDRA  = 0xFE;
 PORTA = 0x00; 
 DDRB  = 0xFF;
 PORTB = 0x1C; 
 PORTC = 0x00; //m103 output only
 DDRC  = 0xFF;
 DDRD  = 0xFF;
 PORTD = 0x00;//0x40; 
 //   : 52 uS 19.2 
 ADCSR = 0x00; //disable adc
 ADMUX = 0x00; //select adc input 0 //    
 ACSR  = 0x80;
 ADCSR = 0xEE; //0xCD; 

 MCUCR = 0x12; 
 GICR  = 0x00;
 TIMSK = 0x00; //timer interrupt sources
 SEI(); //re-enable interrupts
 //all peripherals are now initialized 
 asm("sleep"); //    ,     
}

//
void main(void)
{
 init_devices();
 //insert your functional code here... 
 while(1)
 {
    while(f_adc==0);   
   	
	 
	/*if(f_dynamic == 1)
	{  	
	   if(countRamTek == countRam)
       {
          Ram_ukaz++;
	      if(Ram_ukaz == 24)
	         Ram_ukaz = 0;
	      countRamTek = 0;
       } 
       else
          countRamTek++;
	}  */
	if(Regim == 8)
	{
	   if(countStrTek == countStr)
       {
	      text_to_ram();
          ukaz_text++;		  
	      if(ukaz_text == 190)
	         ukaz_text = 0;
	      countStrTek = 0;
       } 
       else
          countStrTek++;
	   //delay(10);	    	  	  
    }
	else
	{
	   //----------------- 
	   Uolsh1();
	   Uolsh2();
	   Uolsh3();
	   Uolsh4();	
	   Uolsh5();
	   Uolsh6();
	   Uolsh7();
	   Uolsh8();  //  1,2 
	   Uolsh9();
	   Uolsh10();
	   Uolsh11();			  		
       Uolsh12();	
	} 	
		
	f_adc=0;	
	MCUCR = 0x12;    //        
    asm("sleep");	 //           
  } 
}

#pragma interrupt_handler timer0_ovf_isr:10
void timer0_ovf_isr(void)
{
  TCNT0 = 0xB0; //reload counter value   
}


//     19.2kHz
#pragma interrupt_handler adc_isr:15
void adc_isr(void)
{
 //conversion complete, read value (int) using...
 value = ADCL>>2;            //Read 8 low bits first (important)
 value = ADCH<<6;  
 count++; 
  
 if(count==countVD)           // 
 { 
    count = 0;
	countStlbTek++;
	if(countStlbTek == countStolb)//  
    {  
       countStlbTek = 0;
	
       RegimCountTek++;
	   if(RegimCountTek == RegimCount)
	   {
	      RegimCountTek=0;	 
	      if(Regim == 8)
		  {  
		     Regim = 0;
			 //ukaz_text = 0;
			 /*f_dynamic =! f_dynamic; 
			 if(f_dynamic == 1)
			    Ram_ukaz = 0;	
			 else
			    Ram_ukaz = 12;*/				
			 countStrTek = 0;
			 ukaz_text = 0;
			 //countFIR = 512;
			 
		  }
		  else	  
		  {   
		     Regim++;			 
			 //if(Regim == 8)
			 //{	
			 //   countFIR = 64;
			// }
		    // else
			 //   countFIR = 512;				     
		  }      		  
		  	  	 
	   }
	   if(Regim == 1 || Regim == 7)
	   {
	      StolbDown(0);
	      StolbDown(1);
	      StolbDown(2);
	      StolbDown(3);
	      StolbDown(4); 
	      StolbDown(5);
	      StolbDown(6);
	      StolbDown(7);
	      StolbDown(8); 
	      StolbDown(9); 	
	      StolbDown(10);	      
		  StolbDown(11); 
	   }  
    }
	VD_select(); 
 }	
 if(f_adc == 0)               //      
 {
    buffer[countBuf] = value;
    countBuf++; 
  
    if(countBuf==countFIR)    //     
    {
       countBuf=0;
	   f_adc=1;	      	 	  //        
    } 
    else
    { 
       MCUCR = 0x12;          //    ,       
       asm("sleep");
    }
 }
   
}

void adc_interrupt(void)
{
   if(ADCSR&0x10)
   {
      count++;
      if(count==countVD)           // 
      { 
         count = 0;		
         VD_select(); 
      }	
   }   
}

void text_to_ram(void)
{
   Y = 0;
   do
   {
       //ukaz_text = Y+ukaz_text;
       VideoRam[Y] = text[Y+ukaz_text];
	   Y++;
   }
   while(Y < 12);
}

void delay(int ticks)
{
  while(ticks--);
}

//---------------------  
void VD_select(void)
{
    N++;
    switch(N)
	{
	   case 1:
	      //PORTB = 0x1C;
		  PORTD = VideoRam[0];//Uadc1;//privet[ukaz];
		  PORTC = VideoRam[1];//Uadc2;//privet[ukaz+1];
		  PORTA = VideoRam[2]&0xFE;//Uadc3&0xFE;//privet[ukaz+2]&0xFE;
		  portb1 = VideoRam[2]&0x01;//Uadc3&0x01;//privet[ukaz+2]&0x01;
		  PORTB = portb1|0x1C;			  
		  break;	      
	   case 2:
	      PORTD = VideoRam[3];//Uadc4;//privet[ukaz+3];
		  PORTC = VideoRam[4];//Uadc5;//privet[ukaz+4];
		  PORTA = VideoRam[5]&0xFE;//Uadc6&0xFE;//privet[ukaz+5]&0xFE;
		  portb1 = VideoRam[5]&0x01;//Uadc6&0x01;//privet[ukaz+5]&0x01;
		  PORTB = portb1|0x1A;	
		  break;
	   case 3:
	      PORTD = VideoRam[6];//Uadc7;//privet[ukaz+6];
		  PORTC = VideoRam[7];//Uadc8;//privet[ukaz+7];
		  PORTA = VideoRam[8]&0xFE;//Uadc9&0xFE;//privet[ukaz+8]&0xFE;
		  portb1 = VideoRam[8]&0x01;//Uadc9&0x01;//privet[ukaz+8]&0x01;
		  PORTB = portb1|0x16;		  
		  break;	   
	   case 4:	      
		  PORTD = VideoRam[9];//Uadc10;//privet[ukaz+9];
		  PORTC = VideoRam[10];//Uadc11;//privet[ukaz+10];
		  PORTA = VideoRam[11]&0xFE;//Uadc12&0xFE;//privet[ukaz+11]&0xFE;
		  portb1 = VideoRam[11]&0x01;//Uadc12&0x01;//privet[ukaz+11]&0x01;
		  PORTB = portb1|0x0E;
		  N = 0;		  
		  break;	    	  	   
	}		   
}

//---------       
unsigned short isqrt(unsigned int from)
 {
   unsigned int mask = 0x4000, sqr = 0, temp;
   do {
        temp = sqr | mask;
        sqr >>= 1;
        if( temp <= from )
        {
            sqr |= mask;
            from -= temp;
        }
		adc_interrupt(); 
     }
     while( mask >>= 2 );
     //     if( sqr < from ) ++sqr;
     return (unsigned short)sqr;
 }


//    9,6  
// , .      ,     
//  90 ,      , .    
//   0-  
void Uolsh12(void)
{
    Re1 = Re2 = i = ugol2 = 0;	   
	ugol1 = 1;	
	do
	{	
	   adc_interrupt(); 	     
	   //  
	   if(i == ugol1)
	      Re1 = Re1 - buffer[i]; 
	   else
	      Re1 = Re1 + buffer[i];
	   if(i == ugol2)
	      Re2 = Re2 - buffer[i]; 
	   else
	      Re2 = Re2 + buffer[i]; 
	   
	   if(i == ugol1)
       {  ugol1 = ugol1 + 2;
	      ugol2 = ugol2 + 2;
	   }	    
	   i++; 	
	}
	while(i < 16);  	
	    
	//  
	//   	
	if(Re1 > Re2)
	   result1 = Re1>>4; //    16 
	else
	   result1 = Re2>>4; //    16      	
	//   20 	
	result_Volt = 9;
    i=0;
	do
	{
	   adc_interrupt(); 
	   result_Volt--;
       if(result1 <= LOGdft1[i] && result1 >= LOGdft1[i+1])
           break;
	   i++;	   
	}
	while(i<9);	
	
	//        
	 VDshow1(11, 11, result_Volt, 0x001);       
	   
}


//    4,8  
void Uolsh11(void)
{
    tmp = UolshFunc(2, 0, 3, 3, 4, 32, 5);	 
	VDshow2(10, 10,  tmp, 0x002);		        	      
}


//    2,4  
void Uolsh10(void)
{
    tmp = UolshFunc(4, 1, 6, 7, 8, 32, 5);		   
	VDshow1(9, 9, tmp, 0x004);	       	   	       
} 
 
//    1,6  
void Uolsh9(void)
{
    tmp = UolshFunc(6, 2, 9, 11, 12, 60, 6);
	VDshow2(8, 8, tmp, 0x008);		      
}
 
//    1,2  
void Uolsh8(void)
{
    tmp = UolshFunc(8, 3, 12, 15, 16, 64, 6);	
	VDshow1(7, 7, tmp, 0x010); 	  
} 

//    800  
void Uolsh7(void)
{
   tmp = UolshFunc(12, 5, 18, 23, 24, 240, 8);
   VDshow2(6, 6, tmp, 0x020);	   	     	          
} 

//    600  
void Uolsh6(void)
{
    tmp = UolshFunc(16, 7, 24, 31, 32, 256, 8);		   
	VDshow1(5, 5, tmp, 0x040);		        
} 


//    500  
void Uolsh5(void)
{
    tmp = UolshFunc(18, 8, 27, 35, 36, 252, 8);
	VDshow2(4, 4, tmp, 0x080);	 	   
}

//    400  
void Uolsh4(void)
{
    tmp = UolshFunc(24, 11, 36, 47, 48, 240, 8);
	VDshow1(3, 3, tmp, 0x100);	     	  
}

//    300  
void Uolsh3(void)
{
    tmp = UolshFunc(32, 15, 48, 63, 64, 512, 9);
	VDshow2(2, 2, tmp, 0x200); 
}

//    150  
void Uolsh2(void)
{
    tmp = UolshFunc(64, 31, 96, 127, 128, 512, 9);
	VDshow1(1, 1, tmp, 0x400);		      
}
 
//    75  
void Uolsh1(void)
{
    tmp = UolshFunc(128, 63, 192, 255, 256, 512, 9);
	VDshow2(0, 0,  tmp, 0x800);   
}


void VDshow1(unsigned char ukaz_mas, unsigned char ukaz_ram, unsigned char Uabs,unsigned short VDmasTek)
{
   switch(Regim)
	{
	    case 0:  
		  VideoRam[ukaz_ram] = linVD[Uabs]; 
		  break;
		case 1:
		  VideoRam[ukaz_ram] = linVD[Uabs];
	      //Ustolb12 = Stolb(Uadc12, Ustolb12); 
		  Stolb(ukaz_mas, ukaz_ram);             
		  break;
		case 2:
		  VideoRam[ukaz_ram] = linVDdown[Uabs];
		  break;
		case 3:
		  VideoRam[ukaz_ram]= linVDtoch[Uabs];  
		  break; 	
		case 4:
		  if(Uabs > porogVD)
		     VideoRam[ukaz_ram] = 0x00;
	      else
		     VideoRam[ukaz_ram] = 0xFF;
		  break;
		case 5: 
		  VideoRam[ukaz_ram]= linVDpolocka2[Uabs];  
		  break;
		case 6: 
		  VideoRam[ukaz_ram]= linVDpolocka3[Uabs];  
		  break;  
		case 7: 
		  VideoRam[ukaz_ram] = linVD[Uabs];
	      Stolb2(ukaz_mas, ukaz_ram);  
		  break;	  		 		  	
	}     
}

void VDshow2(unsigned char ukaz_mas, unsigned char ukaz_ram, unsigned char Uabs,unsigned short VDmasTek)
{
   switch(Regim)
	{
	   case 0:   case 2:  
	       VideoRam[ukaz_ram] = linVD[Uabs]; 
		   break;
	   case 1:
	       VideoRam[ukaz_ram] = linVD[Uabs];
	       Stolb(ukaz_mas, ukaz_ram);  
		   break;
	   case 3:
	       VideoRam[ukaz_ram] = linVDtoch[Uabs];
		   break;
	   case 4:
		  if(tmp > porogVD)
		     VideoRam[ukaz_ram] = 0x00;
	      else
		     VideoRam[ukaz_ram] = 0xFF;
		  break;
	   case 5: 
		  VideoRam[ukaz_ram]= linVDpolocka2[Uabs];  
		  break;  
	   case 6: 
		  VideoRam[ukaz_ram]= linVDpolocka3[Uabs];  
		  break;
	   case 7: 
		  VideoRam[ukaz_ram] = linVD[Uabs];
	      Stolb2(ukaz_mas, ukaz_ram);  
		  break;	   	  	   		     	   
	}	 
}

//    
void StolbDown(unsigned char ukaz_mas)
{
   if(Ustolb[ukaz_mas] != 0xFF)
   {
      if(f_down[ukaz_mas] == 1)                       
      {  
	     tmp = ~Ustolb[ukaz_mas];
	     Ustolb[ukaz_mas] = ~(tmp>>1);
	  }
	  else
	  {
	     count_down[ukaz_mas]++;
		 if(count_down[ukaz_mas] == 10)
		 {
		    count_down[ukaz_mas] = 0;
		    f_down[ukaz_mas] = 1;			
		 }
	  }  	 
   }    
} 

//         
void Stolb(unsigned char ukaz_mas, unsigned char ukaz_ram)
{
   if(Ustolb[ukaz_mas] != 0xFF)
   {	  
	  if((Ustolb[ukaz_mas]|VideoRam[ukaz_ram]) != 0xFF)
      {   
	      Ustolb[ukaz_mas] = 0x7F;
		  f_down[ukaz_mas] = 0;
		  count_down[ukaz_mas] = 0;
	  }
	   	   
   }
   else
   {
      if(VideoRam[ukaz_ram] != 0xFF)
	  {  
	     Ustolb[ukaz_mas] = 0x7F;
		 f_down[ukaz_mas] = 0;
		 count_down[ukaz_mas] = 0;
	  }	     
   }
   VideoRam[ukaz_ram] = VideoRam[ukaz_ram]&Ustolb[ukaz_mas];
}

//         
void Stolb2(unsigned char ukaz_mas, unsigned char ukaz_ram)
{
   if(Ustolb[ukaz_mas] != 0xFF)
   {	  
	  if((Ustolb[ukaz_mas]|VideoRam[ukaz_ram]) != 0xFF)
      {   
	      StolbADC(ukaz_mas, ukaz_ram);		  
		  //Ustolb[ukaz_mas] = 0x7F;
		  f_down[ukaz_mas] = 0;
		  count_down[ukaz_mas] = 0;
	  }
	   	   
   }
   else
   {
      if(VideoRam[ukaz_ram] != 0xFF)
	  {  
	     //Ustolb[ukaz_mas] = 0x7F;
		 StolbADC(ukaz_mas, ukaz_ram);
		 f_down[ukaz_mas] = 0;
		 count_down[ukaz_mas] = 0;
	  }	     
   }
   VideoRam[ukaz_ram] = VideoRam[ukaz_ram]&Ustolb[ukaz_mas];
}

void StolbADC(unsigned char ukaz_mas, unsigned char ukaz_ram)
{
   switch(VideoRam[ukaz_ram])
   {
	 case 0xFE:
		Ustolb[ukaz_mas] = 0xFE; break;
	 case 0xFC:
	    Ustolb[ukaz_mas] = 0xFD; break;	
	 case 0xF8:
	    Ustolb[ukaz_mas] = 0xFB; break; 	
	 case 0xF0:
		Ustolb[ukaz_mas] = 0xF7; break; 	
	 case 0xE0:
	    Ustolb[ukaz_mas] = 0xEF; break; 
	 case 0xC0:
	    Ustolb[ukaz_mas] = 0xDF; break; 	
	 case 0x80:
	    Ustolb[ukaz_mas] = 0xBF; break; 		 	 		 	 	  
   }
}


//  
//ugol_1 -       1
//ugol_2  ugol_3 -     1
//ugol_4 -           2
//ugol_circle -      
//ugol_count -           ugol_1
//  ugol_count            128 
//del -  .  128   7 64 - 6  . . 2   del
unsigned char UolshFunc(unsigned short ugol_1, unsigned short ugol_2, unsigned short ugol_3, unsigned short ugol_4, 
                        unsigned short ugol_circle, unsigned short ugol_count, unsigned char del)
{
    Re1 = Lm1 = 0;    
	i=0;
	do
	{
	   adc_interrupt(); 	
	   //  , .   sin      0-180  1  -1
	   if(i<ugol_1)
	      Lm1 = Lm1 + buffer[i];
	   else
	      Lm1 = Lm1 - buffer[i];
	   //  
	   if(i>ugol_2 && i<ugol_3)
	      Re1 = Re1 - buffer[i]; 
	   else
	      Re1 = Re1 + buffer[i];
	   if(i == ugol_4)
       {  
	      ugol_1 = ugol_1 + ugol_circle;
	      ugol_2 = ugol_2 + ugol_circle; 
	      ugol_3 = ugol_3 + ugol_circle;
 	      ugol_4 = ugol_4 + ugol_circle;
	   }
	   i++;	   
	}
	while(i<ugol_count);  	
	    
	//          	
	Re1 = Re1>>del; //    2   del
    Lm1 = Lm1>>del; //    2   del
    summ = Re1*Re1 + Lm1*Lm1;
	//   
	result1 = isqrt(summ);	
	//   20 	
	result_Volt = 9;
    i=0;
	do
	{
	    adc_interrupt();
	    result_Volt--;
        if(result1 <= LOGdft1[i] && result1 >= LOGdft1[i+1])
           break;
		i++;   
	}
	while(i<9);			
	
	//Uadc = linVD[result_Volt]; 
	return result_Volt;
} 
